#!/usr/bin/python
import RPi.GPIO as GPIO
import time
import colorsys

GPIO.setmode(GPIO.BCM)
LED1 = [21, 20, 16]
LED2 = [12, 7, 8]
LED3 = [25, 24, 23]
p1 = [0, 0, 0]
p2 = [0, 0, 0]
p3 = [0, 0, 0]

for i in range(3):
  GPIO.setup(LED1[i], GPIO.OUT)
  GPIO.setup(LED2[i], GPIO.OUT)
  GPIO.setup(LED3[i], GPIO.OUT)

for i in range(3):
  p1[i] = GPIO.PWM(LED1[i], 50)
  p1[i].start(0)
  p2[i] = GPIO.PWM(LED2[i], 50)
  p2[i].start(0)
  p3[i] = GPIO.PWM(LED3[i], 50)
  p3[i].start(0)

try:
  while True:
    for i in range(100):
      rgb1 = colorsys.hsv_to_rgb(i/100, 1, 1)
      x2 = i+20
      if x2 > 100:
        x2 -= 100
      rgb2 = colorsys.hsv_to_rgb(x2/100, 1, 1)
      x3 = i+40
      if x3 > 100:
        x3 -= 100
      rgb3 = colorsys.hsv_to_rgb(x3/100, 1, 1)
      for j in range(3):
        p1[j].ChangeDutyCycle(rgb1[j])
        p2[j].ChangeDutyCycle(rgb2[j])
        p3[j].ChangeDutyCycle(rgb3[j])
      time.sleep(0.1)

except KeyboardInterrupt:
  for i in range(3):
    p1[i].stop()
    p2[i].stop()
    p3[i].stop()
  GPIO.cleanup()
